;****************************************************
;lab4
;approx 2 s delay program with 2 status leds to show
;start and end of delay.
;will use tmr0 peripheral w/ interrupts
;****************************************************

	List p=16f84A
	include "P16f84A.inc"		;load the include file
	__CONFIG  _XT_OSC & _WDT_OFF & _CP_OFF & _PWRTE_ON

;declare registers used
		cblock	0x0C
COUNTER
W_TEMP
STATUS_TEMP
		endc

;COUNTER	equ	0x0C

;=====================================================================

		org	0x00		;indicate the start location
	goto	Start

;interrupt vector
		org	0x04
	goto	Int_serv_routine


;program memory here
		org	0x05
;=====================================================================

;call routines

;routine to preload tmr0
Settmr0
	movlw	0x00			;reset tmr0 to count again
	movwf	TMR0			;load tmr0
	return

;routine to preload COUNTER
Setcounter
	movlw	0x1E			;setup counter with countdown value that gives
	movwf	COUNTER			;2 sec delay
	return

;routine to decrement and test COUNTER
Decr_counter
	decf	COUNTER,F		;decrement counter by 1
	btfsc	STATUS,Z		;test to see if (1Eh) rounds of tmr0 have been run
	call	Light_2nd_led		;
	call	Settmr0
	return

;routine to light 2nd led
Light_2nd_led
	bsf	PORTB,3			;light 2nd led to tell when time expired
	return

;====================================================================


Start
	;setup tmr0 and interrupts


;	<//place your code here//>



Portb
	;setup portb

;	<//place your code here//>


Initvar
	;initialize variables used

;	<//place your code here//>


;====================================================================
Main

Light_1st_led

	;light 1st led to tell user code has started delay counter

;	<//place your code here//>

Delay
					;wait here til tmr0 interrupt
	goto	$			;$ = current address... infinite loop


;====================================================================

Int_serv_routine
	;push W and STATUS to save the context
Push

;	<//place your code here//>
	


Filter
	;check to see what caused the interrupt
	;if cause was tmr0 then decrement the counter and see if 2 sec
	;if not, pop back context and return from interrupt

	;don't forget that you must manually clear interrupt flags
	;before returning from interrupts

;	<//place your code here//>

Pop

;	<//place your code here//>

	retfie				;return back since not tmr0 flag


	


	end

