;****************************************************
;lab5
;use approx 2 s flash/delay program to control 2 door motors 
;w/operating cycle period of 2 sec. 
;will use tmr0 peripheral w/ interrupts and porta
;****************************************************

    List p=16f84a
    include "P16f84a.inc"        ;load the include file
    __CONFIG  _XT_OSC & _WDT_OFF & _CP_OFF & _PWRTE_ON

;declare registers used
        cblock  0x0C
COUNTER
STATBIT
W_TEMP
STATUS_TEMP
        endc

;COUNTER    equ 0x0C

;macros
Push macro
    movwf   W_TEMP          ;push W and STATUS
    swapf   STATUS,W        ;
    movwf   STATUS_TEMP     ;
    endm

Pop macro
    swapf   STATUS_TEMP,W       ;pop W and STATUS
    movwf   STATUS          ;
    swapf   W_TEMP,F        ;
    swapf   W_TEMP,W        ;
    endm
;=====================================================================

        org 0x00        ;indicate the start location
    goto    Start

;interrupt vector
        org 0x04
    goto    Int_serv_routine


        org 0x05
;====================================================================
;call routines

;routine to preload tmr0
Settmr0
    movlw   0x00            ;reset tmr0 to count again
    movwf   TMR0            ;load tmr0
    return

;routine to preload COUNTER
Setcounter
    movlw   0x1E            ;setup counter with countdown value that gives
    movwf   COUNTER         ;2 sec delay
    return

;routine to decrement and test COUNTER
Decr_counter
    decf    COUNTER,F       ;decrement counter by 1
    btfsc   STATUS,Z        ;test to see if (1Eh) rounds of tmr0 have been run
    call    Open_close_door     ;
    call    Settmr0
    return

;motor control logic
    ;write a routine that will set or clear a status bit to it's opposite value 
    ;in STATBIT based on it's previous value. STATBIT <0>

    ;if the resulting value is 1 then open the doors
    ;if the resulting value is 0 then close the doors 

 
Open_close_door

;   <//place your code here//>


;open doors
    ;write a routine to turn on the motors in the open direction
    ;then reset the counter for 2 sec delay since it takes 2 sec to open the doors

    ;don't forget to stop the motors current motion first.
    ;this will keep the motor gears from being stripped
Open_phase

;   <//place your code here//>


    return

;close doors
    ;write a routine to turn on the motors in the close direction
    ;then reset the counter for 2 sec delay since it takes 2 sec to close the doors

    ;don't forget to stop the motors current motion first.
    ;this will keep the motor gears from being stripped

Close_phase

;   <//place your code here//>


    return

;setup stat bit 
Setstatbit
    movlw   0x01            ;preload value for statbit
    movwf   STATBIT         ;
;   bsf STATBIT,0       ;setup status bit
    return

;====================================================================

;setup tmr0 and interrupts
Start
    movlw   b'01000111'     ;setup OPTION register
    bsf STATUS,RP0      ;setup bank pointer to access OPTION register
    movwf   OPTION_REG      ;move value into option
    bcf STATUS,RP0      ;clear bank pointer for normal operation
    movlw   b'11100000'     ;setup INTCON register
    movwf   INTCON          ;move value into INTCON

;reset porta/initialize routine
Porta
                    ;clear PORTA
    clrf    PORTA           ;load output latch w/zeros
    bsf STATUS,RP0      ;setup bank pointer to access TRIS register
    clrf    TRISA           ;configure ports to outputs
    bcf STATUS,RP0      ;clear bank pointer for normal operation


;setup stat bit
    call    Setstatbit      ;   

;====================================================================

Main

;light led to tell user code has started delay counter
;   bsf PORTB,0         ;light the LSB (RB0) on PORTB

    call    Settmr0
    call    Setcounter

Delay

    goto    $           ;$ = current address... infinite loop




;======================================================================

Int_serv_routine
    Push


;check to see what caused the interrupt
                    ;test for tmr0 causing interrupt
    btfsc   INTCON,T0IF     ;test tmr0 flag
    call    Decr_counter        ;

    Pop
    bcf INTCON,T0IF     ;clear tmr0 flag
    retfie





    end

