;****************************************************
;lab6b
;use interrupt on INT pin to start door control sequence 
;will use tmr0 peripheral w/ interrupts and porta
;will read RB0 opto switch active lo input 
;****************************************************
    List p=16f84a
    include "P16f84a.inc"        ;load the include file
    __CONFIG  _XT_OSC & _WDT_OFF & _CP_OFF & _PWRTE_ON

;declare registers used
        cblock  0x0C
COUNTER
STATBIT
W_TEMP
STATUS_TEMP
        endc

;COUNTER    equ 0x0C


;macros
Push macro
    movwf   W_TEMP          ;push W and STATUS
    swapf   STATUS,W        ;
    movwf   STATUS_TEMP     ;
    endm

Pop macro
    swapf   STATUS_TEMP,W       ;pop W and STATUS
    movwf   STATUS          ;
    swapf   W_TEMP,F        ;
    swapf   W_TEMP,W        ;
    endm
;=====================================================================

        org 0x00        ;indicate the start location
    goto    Start

;interrupt vector
        org 0x04
    goto    Int_serv_routine


        org 0x05
;=================================================================
;call routines

;routine to preload tmr0
Settmr0
    movlw   0x00            ;reset tmr0 to count again
    movwf   TMR0            ;load tmr0
    return

;routine to preload COUNTER 
Setcounter
    movlw   0x1E            ;setup counter with countdown value that gives
    movwf   COUNTER         ;2 sec delay
    return

;routine to preload STATBIT
Setstatbit
    movlw   0x04            ;setup 4 state cycle counter
    movwf   STATBIT         ;load status bit
    return

;routine to setup interrupts for tmr0
    ;write a routine to setup for only tmr0 interrupts.
    ;must disable all other interrupts as well.
Tmr0ints

;   <//place your code here//>


    return

;routine to setup interrupts for INT pin
    ;write a routine to setup for only INT pin interrupts.
    ;must disable all other interrupts as well.
 
Intints

;   <//place your code here//>


    return

;routine to decrement and test COUNTER
Decr_counter
    decf    COUNTER,F       ;decrement counter by 1
    btfsc   STATUS,Z        ;test to see if 76x (4Ch) rounds of tmr0 have been run
    call    Open_close_door     ;
    call    Settmr0
    return

;motor control logic
Open_close_door
                    ;test status bit to see which direction to drive
    decf    STATBIT,F       ;decr state machine
    movlw   0x03            ;load W with state to test against
    subwf   STATBIT,W       ;sub to test state 4
    btfsc   STATUS,Z        ;test to see what phase
    goto    Open_phase      ;
    movlw   0x02            ;load W with state to test against
    subwf   STATBIT,W       ;sub to test state 1    
    btfsc   STATUS,Z        ;test to see what phase
    goto    Close_phase     ;
    movlw   0x01            ;load W with state to test against
    subwf   STATBIT,W       ;sub to test state 1
    btfsc   STATUS,Z        ;test to see what phase
    goto    End_phase       ;

;open doors
Open_phase
                    ;turn motors on in open direction
                    ;must stop previous direction 1st
    clrf    PORTA           ;stop previous movement
    movlw   b'00000110'     ;load W with value to xor
    xorwf   PORTA,F         ;bit toggle control bits 
    call    Setcounter
    return

;close doors
Close_phase
                    ;turn motors on in close direction
                    ;must stop previous direction 1st
    clrf    PORTA           ;stop previous movement
    movlw   b'00001001'     ;load W with value to xor
    xorwf   PORTA,F         ;bit toggle control bits 
    call    Setcounter
    return

;stop motors/end of cycle
    ;write a routine to stop all the motors.
    ;Then reset the 2 second counter and 3 state state machine.
    ;Finally setup and check for the next INT interrupt before restarting the 
    ;motor control state machine.


End_phase

;   <//place your code here//>

    return
    
;=================================================================

Start

;reset ports/initialize routine
Porta
                    ;clear PORTA
    clrf    PORTA           ;load output latch w/zeros
    bsf STATUS,RP0      ;setup bank pointer to access TRIS register
    clrf    TRISA           ;configure ports to outputs
    bcf STATUS,RP0      ;clear bank pointer for normal operation

Portb
                    ;clear PORTB
    clrf    PORTB           ;load output latch w/zeros
    movlw   0xFF            ;load FF into W
    bsf STATUS,RP0      ;setup bank pointer to access TRIS register
    movwf   TRISB           ;configure ports to inputs
    bcf STATUS,RP0      ;clear bank pointer for normal operation

;=========================

    ;write code to configure the timers, counters, and state machine.

;   <//place your code here//>



;=========================

    ;write code to configure option/intcon and read the 
    ;INT pin interrupt appropriately.
 


;   <//place your code here//>




;====================================================================

MAIN



    ;then configure the part to wait for an INT interrupt before
    ;servicing the appropriate interrupt.

;   <//place your code here//>


;======================================================================

Int_serv_routine


    Push

;check to see what caused the interrupt

    ;write a routine to filter out and decide what caused
    ;the interrupt.
    
    ;if the cause was INT, then clear the interrupt and 
    ;restore the context.
    
    ;if the cause was tmr0, then start the motor state machine
    ;and timing delays appropriately.
    ;don't forget to restore the context when done.
 
;routine to check INT causing interrupt
RB0_INT

;   <//place your code here//>

    retfie

;routine to check tmr0 causing interrupt
Tmr0_int


;   <//place your code here//>

    retfie







    end

