	list	p=12c672
	
	include "p12c672.inc"
	__config _MCLRE_OFF&_CP_OFF&_PWRTE_ON&_WDT_OFF&_INTRC_OSC_NOCLKOUT
PWM_Period	equ	0xff
	cblock	0x20
	PWM_DutyCycle
	PWM_Sum
	TEMP
	CONVERTVALUE
	BASELINE
	MINVALUE
	RUNAVERAGE
	SENSEDLY
	SENSEDLY1
	ADDELYCNT
	STATUS_TEMP
	W_TEMP
	endc	

#define ADCYCLDLY   10
#define PWM_PORT    GPIO
#define PWM_PIN     2
#define TRISMASK    B'00000001'


	org	03ffh
OscCall	retlw	080h

	org	0	
	goto	Main

	org	04h
	goto	SWPWM12
Main
	movwf	OSCCAL
	clrf	BASELINE
	clrf	ADDELYCNT
	call	OpenSWPWM
	movlw	0x05
	movwf	PWM_DutyCycle
	movwf	MINVALUE
	bsf	STATUS,RP0
	call	OscCall
	movwf	OSCCAL
	movlw	006h
	movwf	ADCON1
	movlw	B'10001000'
	movwf	OPTION_REG
	bcf	STATUS,RP0
	movlw	B'10000000'
	movwf	ADCON0
	movlw	B'10100000'
	movwf	INTCON
	movlw	0d8h
	movwf	TMR0
	movlw	B'10000001'
	movwf	ADCON0

	call	Convert
	movf	CONVERTVALUE,W
	movwf	BASELINE
MainLoop
	movlw	ADCYCLDLY
	subwf	ADDELYCNT,W
	btfss	STATUS,Z
	goto	MainLoop
	clrf	ADDELYCNT
	call	Convert
	movf	CONVERTVALUE,W
	subwf	BASELINE,W
	btfsc	STATUS,C
	goto	NoNewBase
	movf	CONVERTVALUE,W
	movwf	BASELINE

NoNewBase
	movf	CONVERTVALUE,W
	subwf	MINVALUE,W
	btfss	STATUS,C
	goto	NoNewMin
	movf	CONVERTVALUE,W
	movwf	MINVALUE
	
NoNewMin
	movf	CONVERTVALUE,W
	subwf	BASELINE,W
	addwf	RUNAVERAGE,W
	btfss	STATUS,C
	goto	NoCarry
	movwf	RUNAVERAGE
	bcf	STATUS,C
	rrf	RUNAVERAGE,W
	addlw	080h
	goto	SetPWM
NoCarry
	movwf	RUNAVERAGE
	bcf	STATUS,C
	rrf	RUNAVERAGE,W
SetPWM
	movwf	PWM_DutyCycle
	movwf	RUNAVERAGE
	call	DelayForSensor
	movf	CONVERTVALUE,W
	addlw	004h
	subwf	BASELINE,W
	btfsc	STATUS,C
	goto	MainLoop
	movlw	0F0h
	subwf	BASELINE,W
	btfss	STATUS,C
	goto	MainLoop
	decf	BASELINE,F
	goto	MainLoop
	
Convert
;	call	SWPWM12
	bsf	STATUS,RP0
	bsf	TRISIO,0
	movlw	006h
	movwf	ADCON1
	bcf	STATUS,RP0
	bsf	GPIO,1
	call	DelayCall
	call	DelayCall
	call	DelayCall
	call	DelayCall

	bsf	ADCON0,GO_DONE
ConvertLoop
	btfsc	ADCON0,GO_DONE
	goto	ConvertLoop
	bcf	GPIO,1
	movf	ADRES,W
	movwf	CONVERTVALUE

	bsf	STATUS,RP0
	movlw	007h
	movwf	ADCON1
	bcf	TRISIO,0
	bcf	STATUS,RP0
	bcf	GPIO,1
DelayCall
	return

DelayForSensor
	movlw	03h
	movwf	SENSEDLY
Sensedelay
	movlw	020h		;was 20h
	movwf	SENSEDLY1
Sensedelay1
	decfsz	SENSEDLY1,F
	goto	Sensedelay1
	decfsz	SENSEDLY,F
	goto	Sensedelay
	return

; *******************************************************************
;   Plug in Libraries for the by 12 architecture                    *
;   Written and Tested using MPASM V1.40                            *
;********************************************************************
;   Filename:		SWPWM12.ASM                                 *
;   Date:               05 November 1997                            *
;   File Version:       1.00                                        *
;********************************************************************
;  Macros:
;                       SetPWMDutyCycle - Number of steps out of the
;                                         period that will be high
;                       SetPWMPeriod    - Set number of steps that
;                                         define the PWM cycle.
;
;  Functions:
;                       OpenSWPWM       - Defines the port and pin
;                                         that will be PWM'd, along
;                                         with the rest of the TRIS mask.
;                       SWPWM12         - Advances PWM State machine
;
;  Internal Variables
;                       PWM_DutyCycle
;                       PWM_Sum
;                       PWM_Period
;********************************************************************
;   Revision History:                                               *
;      V1.00 - Beta release of Peripheral Libraries                 *
;********************************************************************
;   Notes:                                                          *
; *******************************************************************
; Change these definitions as needed and reassemble the library     *
;                                                                   *
        title "Software PWM functions for by12 architecture"
;



portmask = ~(0x01 << PWM_PIN) & TRISMASK


;
;
;*****************************************************************
;	Function Name:	OpenSWPWM                                *
;	Return Value:	none                                     *
;	Parameters:	None (parameters set at assembly time)   *
;	RAM Usage:	0 bytes                                  *
;	ROM Usage:	7 words                                  *
;	Description:	Sets the TRIS register for the PWMPORT   *
;			such that the PWM_PIN is an output, and  *
;                       the rest of the bits are as specified by *
;                       TRISMASK.                                *
;*****************************************************************
OpenSWPWM
	bcf	PWM_PORT,PWM_PIN	; Start it off low
	movlw	portmask
	tris	PWM_PORT		; Set PWM pin for output
	clrf	PWM_Sum		; clear the sum
        clrf    PWM_DutyCycle   ; min duty cycle (0)
	retlw   0

;*****************************************************************
;	Function Name:	SWPWM12                                  *
;	Return Value:	none                                     *
;	Parameters:	None (parameters set at assembly time)   *
;	RAM Usage:	0 bytes                                  *
;	ROM Usage:	5 words                                  *
;	Description:	Advances the state of the PWM state      *
;			machine and changes the state of the pin *
;                       if necessary.                            *
;*****************************************************************
SWPWM12
	movwf	W_TEMP
	swapf	STATUS,W
	bcf	STATUS,RP0
	movwf	STATUS_TEMP

	incf	ADDELYCNT,F
	bcf	INTCON,T0IF
	movlw	0d8h
	movwf	TMR0
	incf	PWM_Sum,f 		; bump the counter

        movlw   PWM_Period      ; compare the sum against the period.
        subwf   PWM_Sum,w
        btfss   STATUS,Z        ; if the sum == period,
	goto	NotPeriod
        clrf    PWM_Sum         ; reset the sum.


NotPeriod
	movf	PWM_DutyCycle,w
	subwf	PWM_Sum,w	; compare against the duty cycle
	btfsc	STATUS,C	; If Sum < duty cycle
	goto	pwmlow

pwmhi	bsf	PWM_PORT,PWM_PIN
	goto	OutOfInt

pwmlow  
	bcf	PWM_PORT,PWM_PIN
OutOfInt
	swapf	STATUS_TEMP,W
	movwf	STATUS
	swapf	W_TEMP,F
	swapf	W_TEMP,W
	retfie
	end
